"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FormComponent = function (_Component) {
	_inherits(FormComponent, _Component);

	function FormComponent() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, FormComponent);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = FormComponent.__proto__ || Object.getPrototypeOf(FormComponent)).call.apply(_ref, [this].concat(args))), _this), _this.getDataWithProps = function () {
			var form = _this.context.form;
			var _this$props = _this.props,
			    id = _this$props.id,
			    validation = _this$props.validation,
			    postValidation = _this$props.postValidation,
			    validators = _this$props.validators,
			    _this$props$component = _this$props.component,
			    component = _this$props$component === undefined ? {} : _this$props$component;


			var data = form.getField(id);

			return _extends({
				validation: validation,
				postValidation: postValidation,
				validators: _extends({}, validators, component.validators || {}),
				value: null,
				error: null,
				valid: true
			}, data);
		}, _this.onChange = function (value) {
			var form = _this.context.form;
			var id = _this.props.id;


			form.onChange(_extends({}, _this.getDataWithProps(), {
				value: value
			}), id);
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(FormComponent, [{
		key: "componentWillMount",
		value: function componentWillMount() {
			var form = this.context.form;
			var id = this.props.id;

			if (!form) throw new Error("FormComponent must be used within the context of a Flum Form");

			form.onChange(this.getDataWithProps(), id);
		}
	}, {
		key: "render",
		value: function render() {
			var form = this.context.form;
			var _props = this.props,
			    id = _props.id,
			    children = _props.children,
			    Component = _props.component,
			    componentProps = _props.componentProps;


			var data = form.getField(id);
			var injectedProps = {
				id: id,
				onChange: this.onChange,
				value: data.value,
				error: data.error
			};

			if (Component) return _react2.default.createElement(Component, _extends({}, componentProps, injectedProps));
			return children(injectedProps);
		}
	}]);

	return FormComponent;
}(_react.Component);

FormComponent.contextTypes = {
	form: _react.PropTypes.object
};
FormComponent.propTypes = {
	id: _react.PropTypes.string.isRequired,
	validation: _react.PropTypes.string,
	postValidation: _react.PropTypes.string,
	validators: _react.PropTypes.object,
	children: _react.PropTypes.func,

	component: _react.PropTypes.func,
	componentProps: _react.PropTypes.object
};
exports.default = FormComponent;