'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _Validation = require('../Utils/Validation');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Validation = function (_Component) {
	_inherits(Validation, _Component);

	function Validation() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, Validation);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Validation.__proto__ || Object.getPrototypeOf(Validation)).call.apply(_ref, [this].concat(args))), _this), _this.getDefaultState = function () {
			return {
				value: _this.props.defaultValue,
				error: null,
				valid: true
			};
		}, _this.getValue = function () {
			var value = _this.props.value;

			return _extends({}, _this.getDefaultState(), value || {});
		}, _this.buildField = function (value) {
			var _this$props = _this.props,
			    validation = _this$props.validation,
			    validators = _this$props.validators,
			    postValidation = _this$props.postValidation,
			    pattern = _this$props.pattern,
			    patternError = _this$props.patternError;


			var fieldData = _this.getValue();

			return _extends({}, fieldData, {
				validators: validators,
				validation: validation,
				postValidation: postValidation,
				pattern: pattern,
				patternError: patternError,
				value: value === undefined ? fieldData.value : value,
				__flum: true
			});
		}, _this.onChange = function (value) {
			var onChange = _this.props.onChange;

			var field = _this.buildField(value);

			onChange((0, _Validation.validateField)(field));
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(Validation, [{
		key: 'componentDidMount',
		value: function componentDidMount() {
			this.onChange();
		}
	}, {
		key: 'render',
		value: function render() {
			var children = this.props.children;

			var state = this.getValue();

			return children ? children({
				value: state.value,
				error: state.error,
				valid: state.valid,
				onChange: this.onChange
			}) : null;
		}
	}]);

	return Validation;
}(_react.Component);

Validation.propTypes = {
	children: _react.PropTypes.func,

	value: _react.PropTypes.any,
	onChange: _react.PropTypes.func,

	pattern: function pattern(props, propName) {
		if (props[propName] && typeof props[propName].test !== 'function') {
			return new Error("A valid regex string must be supplied for `pattern`");
		}
	},
	patternError: _react.PropTypes.string,

	validation: _react.PropTypes.string,
	postValidation: _react.PropTypes.string,

	validators: _react.PropTypes.object,
	defaultValue: _react.PropTypes.any
};
exports.default = Validation;