'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.buildState = exports.flattenState = undefined;

var _mapValues2 = require('lodash/mapValues');

var _mapValues3 = _interopRequireDefault(_mapValues2);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/* Utility that flattens a piece of state by
 * selecting each keys 'value' property.
 * */
var flattenState = exports.flattenState = function flattenState(state) {
	return (0, _mapValues3.default)(state, function (piece) {
		if ((typeof piece === 'undefined' ? 'undefined' : _typeof(piece)) !== 'object') return piece;
		if (piece.__flum) return piece.value;
		return flattenState(piece);
	});
};

var buildState = exports.buildState = function buildState(state, field, path) {
	if (path) {
		var _ret = function () {
			var keys = path.split(".");

			var setIn = function setIn() {
				var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

				if (keys.length == 1) return field;
				keys.splice(0, 1);
				return _extends({}, state, _defineProperty({}, keys[0], setIn(state[keys[0]])));
			};

			return {
				v: _extends({}, state, _defineProperty({}, keys[0], setIn(state[keys[0]])))
			};
		}();

		if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
	}
	return field;
};