"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _get2 = require("lodash/get");

var _get3 = _interopRequireDefault(_get2);

var _find2 = require("lodash/find");

var _find3 = _interopRequireDefault(_find2);

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
	"min-length": function minLength(_ref) {
		var value = _ref.value,
		    args = _ref.args;

		var _args = _slicedToArray(args, 1),
		    amount = _args[0];

		if (value.length > amount) return {
			valid: true
		};

		return {
			valid: false,
			error: "Must be more than " + amount + " characters"
		};
	},
	"max-length": function maxLength(_ref2) {
		var value = _ref2.value,
		    args = _ref2.args;

		var _args2 = _slicedToArray(args, 1),
		    amount = _args2[0];

		if (value.length < amount) return {
			valid: true
		};

		return {
			valid: false,
			error: "Must be less than " + amount + " characters"
		};
	},
	min: function min(_ref3) {
		var value = _ref3.value,
		    args = _ref3.args;

		var _args3 = _slicedToArray(args, 1),
		    amount = _args3[0];

		if (value >= amount) return {
			valid: true
		};

		return {
			valid: false,
			error: "Cannot be less than " + amount
		};
	},
	max: function max(_ref4) {
		var value = _ref4.value,
		    args = _ref4.args;

		var _args4 = _slicedToArray(args, 1),
		    amount = _args4[0];

		if (value <= amount) return {
			valid: true
		};

		return {
			valid: false,
			error: "Cannot be more than " + amount
		};
	},
	between: function between(_ref5) {
		var value = _ref5.value,
		    args = _ref5.args;

		var _args5 = _slicedToArray(args, 2),
		    min = _args5[0],
		    max = _args5[1];

		if (value.length < max && value.length > min) return {
			valid: true
		};

		return {
			valid: false,
			error: "Must be between " + min + " and " + max
		};
	},
	numeric: function numeric(_ref6) {
		var value = _ref6.value;

		if (value == '' || /^[0-9]*$/.test(value)) return {
			valid: true
		};

		return {
			valid: false,
			error: "Can only contain numbers"
		};
	},
	letters: function letters(_ref7) {
		var value = _ref7.value;

		if (value == '' || /^[A-z ]*$/.test(value)) return {
			valid: true
		};

		return {
			valid: false,
			error: "Cannot contain letters"
		};
	},
	alphanumeric: function alphanumeric(_ref8) {
		var value = _ref8.value;

		if (value == '' || /^[A-z0-9]*$/.test(value)) return {
			valid: true
		};

		return {
			valid: false,
			error: "Can only contain numbers and letters"
		};
	},
	email: function email(_ref9) {
		var value = _ref9.value;

		if (/^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/.test(value)) return {
			valid: true
		};

		return {
			valid: false,
			error: "Must be a valid email address"
		};
	},
	equals: function equals(_ref10) {
		var value = _ref10.value,
		    args = _ref10.args;

		if ((0, _find3.default)(args, function (val) {
			return val == value;
		})) return {
			valid: true
		};

		return {
			valid: false,
			error: "Invalid"
		};
	},
	required: function required(_ref11) {
		var value = _ref11.value;

		if (value && value != "") return {
			valid: true
		};

		return {
			valid: false,
			error: "Required"
		};
	},
	matches: function matches(_ref12) {
		var value = _ref12.value,
		    args = _ref12.args,
		    state = _ref12.state;

		var _args6 = _slicedToArray(args, 1),
		    path = _args6[0];

		var field = (0, _get3.default)(state, path, {});
		if (field && value == field.value) return { valid: true };

		var split = path.split(".");
		return {
			valid: false,
			error: "Must match " + split[split.length - 1]
		};
	}
};